2010-02-18  Marek Habersack  <mhabersack@novell.com>

	* HostingEnvironment.cs: removed SetHostingId and added internal
	setters to the SiteName and IsHosted properties.

	* ApplicationManager.cs: CreateHost doesn't have to call set
	HostingEnvironment.IsHosted, it is done in
	ApplicationHost.CreateApplicationHost.

	* ApplicationHost.cs: set the ".appId" item in the new appdomain's
	data, so that HttpRuntime.AppDomainAppId returns a non-null
	value.
	Set HostingEnvironment.{IsHosted, SiteName} in the new appdomain
	instead of the original one.

	All of the above fix bug #578880

2010-01-14  Marek Habersack  <mhabersack@novell.com>

	* ApplicationManager.cs: implemented a missing CreateObject
	overload

2009-11-18  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: changed the order of file names in
	WebConfigFileNames, so that our global web.config is found first
	(it's frequently accessed)

2009-10-20 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* ApplicationHost.cs: set the shadow copy options calling the methods
	in AppDomain, instead of setting them in a copy of the setup
	information.

2009-10-14 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* ApplicationHost.cs: use shadowCopyBinAssemblies from
	<hostingEnvironment>.

2009-09-07  Marek Habersack  <mhabersack@novell.com>

	* HostingEnvironment.cs: MapPath checks if HttpContext.Request
	actually exists before using it.

2009-08-26  Marek Habersack  <mhabersack@novell.com>

	* IApplicationHost.cs: added

2009-07-10 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* SimpleWorkerRequest.cs: move this back to an instance property.
	Cache works now.

2009-07-09 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* SimpleWorkerRequest.cs: store the root web configuration path in a
	static variable.

2009-02-19  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: added support for the
	__MONO_DOMAIN_ID_SUFFIX environment variable, used by mod_mono.

2008-10-29  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: set domain setup CachePath to the same value
	as DynamicBase, so that shadow-copied assemblies appear under the
	same location what generated files.

2008-05-13  Gert Driesen  <drieseng@users.sourceforge.net>

	* VirtualPathProvider.cs: Removed debug code.

2008-04-08  Marek Habersack  <mhabersack@novell.com>

	* DefaultVirtualDirectory.cs: fixed the constructor - derive
	virtual directory from the original path.
	AddDirectories and AddFiles combine the virtual paths properly
	now.

2008-04-01  Marek Habersack  <mhabersack@novell.com>

	* HostingEnvironment.cs: initialize custom VPP on
	registration.
	Added an internal boolena property to signal if we're using a
	custom VPP or not (HaveCustomVPP)

2008-03-31  Marek Habersack  <mhabersack@novell.com>

	* VirtualPathProvider.cs: internal SetPrevious method renamed to
	InitializeAndSetPrevious.

2008-03-27  Marek Habersack  <mhabersack@novell.com>

	* DefaultVirtualPathProvider.cs: support relative virtual paths in
	all the methods.

	* VirtualPathProvider.cs: FileExists should chain to the previous
	handler, if present.

2008-03-13  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: use HttpRuntime.CaseInsensitive when
	checking whether we're running in a case-insensitive environment.
	Revert to the single-bin-dir behavior when setting the
	PrivateBinPath - the directories are sought for in the order given
	by HttpApplication.BinDirs and the first existing directory is set
	as the value of PrivateBinPath. If none of those are found,
	PrivateBinPath defaults to "bin" (and "/app/full/path/bin" in the
	2.0 profile)

2008-03-12  Marek Habersack  <mhabersack@novell.com>

	* DefaultVirtualPathProvider.cs: disable throwing an exception
	when a virtual path is passed to FileExists.

2008-02-18  Marek Habersack  <mhabersack@novell.com>

	* VirtualPathProvider.cs: chain up to the previous provider, if
	prexent. Fixes bug #362038

2008-01-06  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: make sure that application with virtualDir
	"/a" and physicalDir "/b" and the other way around get different
	domain_id values.

2007-12-13  Marek Habersack  <mhabersack@novell.com>

	* ApplicationManager.cs, ApplicationHost.cs,
	DefaultVirtualPathProvider.cs: speed optimization - use
	String.Concat instead of String.Format in some cases.

2007-11-03  Gert Driesen  <drieseng@users.sourceforge.net>

	* ApplicationHost.cs: On 2.0, also make PrivateBinPath an absolute
	paths on Windows (and on systems using MONO_IOMAP).

2007-11-03  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: AppDomainSetup.PrivateBinPath is a list of
	full paths on 2.0.

2007-10-24  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: ignore exceptions resulting from the attempt
	to delete a stamp directory in CreateApplicationHost. It is safe
	to do so, since the code inside the loop serves the only purpose
	to create the asp.net temporary directory if the filesystem
	permissions allow it. If the directory has been deleted by some
	other thread, that's ok.

2007-10-17  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: introduce an application domain data item to
	allow checks for whether System.Web code runs inside a hosted
	application or in a stand-alone one.
	Made the array of web.config name variations an internal one, to
	be used from within configuration code.

2007-08-24  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: use ; as the separator with PrivateBinPath.

2007-08-23  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: set AppDomainSetup.PrivateBinPath to "bin"
	if running on Windows or with MONO_IOMAP in effect, and to
	"Bin:bin" otherwise.

2007-08-21  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: AppDomainSetup.PrivateBinPath should contain
	a list of paths relative to AppDomainSetup.ApplicationBase, not a
	full path.
	We no longer check if the bin directories exist, the user can
	create them while the application is running.

2007-07-21  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: ClearDynamicBaseDirectory becomes an
	internal method.

2007-07-12  Marek Habersack  <mhabersack@novell.com>

	* HostingEnvironment.cs: allow relative paths to be
	passed. Matches both MSDN and the MS.NET behavior. Fixes bug
	#82061.

2007-05-09 Igor Zelmanovich <igorz@mainsoft.com>

	* ApplicationHost.cs:
	added MonoNotSupported attribute for TARGATE_JVM.	

2007-04-13  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: clear the dynamic base directory before
	creating the host. Fixes bug #80635

2007-04-05  Marek Habersack  <mhabersack@novell.com>

	* ApplicationHost.cs: make ApplicationName/domain id really
	unique.

2007-02-21  Marek Habersack  <grendello@gmail.com>

	* ApplicationHost.cs: support both Bin and bin directories, prefer
	the former.

2007-02-19  Marek Habersack  <grendello@gmail.com>

	* ApplicationHost.cs: Use a deterministic application name, so
	that the temporary location is always in the same place for the
	given app.

2007-01-30  Marek Habersack  <grendello@gmail.com>

	* ApplicationHost.cs: Define AppDomain data item "DataDirectory" - used
	by the ADO.NET |DataDirectory| connection string placeholder. Present
	by default in MS.NET.

2007-01-20  Miguel de Icaza  <miguel@novell.com>

	* ApplicationManager.cs: Remove unused variable.
	(ShutdownAll) remove unused variables.

	* ApplicationHost.cs: Protect create_dir lock 

2007-01-19  Marek Habersack  <grendello@gmail.com>

	* SimpleWorkerRequest.cs: If path is empty, return the physical
	application directory. Fixes bug #80544.

2007-01-17  Adar Wesley <adarw@mainsoft.com>

	* ApplicationHost.cs: tweaking CreateApplicationHost to throw the 
	right exceptions so the tests will pass.

2007-01-11  Adar Wesley <adarw@mainsoft.com>

	* ApplicationHost.cs: fixed AppDomain initialization of physical
	path to be in file system semantics

2006-12-22  Marek Habersack  <grendello@gmail.com>

	* HostingEnvironment.cs: implemented the SetCultures methods.

2006-12-19 Igor Zelmanovich <igorz@mainsoft.com>

	* ServletWorkerRequest.cs: fixed:
	Path.Combine is used in GetFilePathTranslated to consider 
	platform-depended PathSeparator char.

2006-12-07  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ServletWorkerRequest.jvm.cs: fixed request uri unescaping in
	ServletWorkerRequest ctor

2006-11-24  Miguel de Icaza  <miguel@novell.com>

	* ApplicationHost.cs: In 2.0, as Todd reports the default is
	"Web.Config", try that before we tell people to use MONO_IOMAP=all ;-)

2006-11-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: the new Directory code throws if the directory
	exists, so handle that as gracefully as possible.

2006-08-23 Konstantin Triger <kostat@mainsoft.com>

	* ServletWorkerRequest.jvm.cs: fix default page resolution.

2006-08-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BareApplicationHost.cs:
	* ApplicationManager.cs: remove unloaded domains.

2006-03-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SimpleWorkerRequest.cs: use UrlUtils instead of Path. Several fixes
	to make PathInfo + SimpleWorkerRequest work as in MS.

2006-03-15  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ServletWorkerRequest.jvm.cs: fixed ctor, UrlDecode applied on 
	requested url
	fixed GetRawUrl, removed protocol, hostname and port
	fixed GetUriPath, _requestUri is always initialized

2006-03-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: ShadowCopyDirectories is not a URL. Set
	PrivateBinPath to the same value.

2006-03-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BareApplicationHost.cs: initialize paths from AppDomain data. New
	GetCodeGenDir().
	* ApplicationHost.cs: in 2.0 the physical path is turned into an
	absolute path.

2006-02-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationManager.cs: new internal method to create/reuse a
	BareApplicationHost from ClientBuildManager.

2006-02-28  Chris Toshok  <toshok@ximian.com>

	* IAppDomainFactory.cs: corcompare work.

	* IAppManagerAppDomainFactory.cs: same

	* IISAPIRuntime.cs: same.

2006-02-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationManager.cs: implemented ShutdownAll().
	* HostingEnvironment.cs: remove MonoTODO.

2006-02-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BareApplicationHost.cs: class used as an entry point into each
	application domiain from the ApplicationManager.
	* ApplicationManager.cs: implemented most of the remaining methods.
	* HostingEnvironment.cs: object handling methods are now implemented.

2006-02-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DefaultVirtualPathProvider.cs: add some comments/TODO.
	* HostingEnvironment.cs: initialize the default value for
	VirtualPathProvider.

2006-02-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HostingEnvironment.cs: MapPath is done.

2006-02-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DefaultVirtualDirectory.cs: implemented missing bits.
	* DefaultVirtualFile.cs: fix ctor scope.
	* DefaultVirtualPathProvider.cs: implemented GetFile and GetDirectory.

2006-02-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DefaultVirtualDirectory.cs:
	* DefaultVirtualPathProvider.cs:
	* VirtualFile.cs:
	* DefaultVirtualFile.cs: almost done with the default
	VirtualPathProvider which just maps to on-disk directories/files.

2006-02-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SimpleWorkerRequest.cs: implemented RootWebConfigPath.
	* HostingEnvironment.cs: implemented RegisterVirtualPathProvider and
	a few other defaults.

2006-01-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AppManagerAppDomainFactory.cs: stubbed out.

	* ApplicationInfo.cs:
	* ApplicationManager.cs: add 2 new classes.

2006-01-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* VirtualPathProvider.cs: implemented OpenFile.
	* VirtualFile.cs: removed stuff cut&pasted from VirtualDirectory.

	* SimpleWorkerRequest.cs: 
	* HostingEnvironment.cs: class status fixes.

2006-01-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* IProcessHostFactoryHelper.cs:
	* IProcessPingCallback.cs:
	* IProcessHost.cs:
	* IProcessHostSupportFunction.cs:
	* IHttpWorkerRequestHandler.cs:
	* IQueueHost.cs:
	* IApplicationHost.cs: removed all this. They are not longer part of the
	public API.

2006-01-25 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* VirtualDirectory.cs:
	* VirtualPathProvider.cs:
	* VirtualFileBase.cs:
	* VirtualFile.cs: implemented this base classes.

	* HostingEnvironment.cs: implemented a few properties by using the ones
	in HttpRuntime.

2006-01-24  Konstantin Triger <kostat@mainsoft.com>

	* ServletWorkerRequest.jvm.cs: convert .invoke requests to PathInfo,
		remove ToUpper usage.

2006-01-19  Konstantin Triger <kostat@mainsoft.com>

	* ServletWorkerRequest.jvm.cs: refactoring.

2005-11-28  Robert Jordan  <robertj@gmx.net>

	* SimpleWorkerRequest.cs: fixed MapPath () for the case
	app_virtual_dir.Length == 1 && path.Length == 1.
	* SimpleWorkerRequest.cs: implemented SendResponseFromMemory ().

2005-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: make this work with paths that that
	contain non-ASCII characters. Fixes bug #76807.

2005-11-02  Chris Toshok  <toshok@ximian.com>

	* HostingEnvironment.cs: completely NIE'ed implementation of
	HostingEnvironment, just to get an MS example provider to compile.

2005-11-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: use the AbsolutePath from the Uri to remove the
	schema prefix if present.

2005-09-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SimpleWorkerRequest.cs: all tests pass now.

2005-09-26 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: append a directory separator char to the physical
	path. Fixes bug #76187.

2005-09-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SimpleWorkerRequest.cs: fix GetUriPath() for paths ending in '/'.

2005-09-10  Sebastien Pouliot  <sebastien@ximian.com>

	* AppDomainFactory.cs: Added LinkDemand for Minimal. Added Demand for
	UnmanagedCode on ctor. Added TODO on unimplemented method.
	* ApplicationHost.cs: Added LinkDemand for Minimal. Added Demand for 
	UnmanagedCode on ctor. Removed duplicate null checks.
	* ISAPIRuntime.cs: Fixed inheritance (added MarshalByRefObject and 
	IRegisteredObject) for 2.0. Added LinkDemand for Minimal. Added Demand 
	for UnmanagedCode on ctor.
	* SimpleWorkerRequest.cs: Added LinkDemand and InheritanceDemand (not
	sealed) for Minimal. Added Demands for UnmanagedCode on ctors. Added
	FileIOPermission for PathDiscovery before returning processed paths.

2005-09-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: set the domain's DynamicBase property instead of
	guessing it in BaseCompiler.

2005-09-08  Eyal Alalouf  <eyala@mainsoft.com>
	* ServletWorkerRequest.jvm.cs: Implement SendResponseFromFile

2005-07-24  Eyal Alalouf  <eyala@mainsoft.com>
	* ServletWorkerRequest.jvm.cs: Put Console.WriteLine in #if DEBUG

2005-07-18  Eyal Alalouf  <eyala@mainsoft.com>

	* Added ServletWorkerRequest.jvm.cs

2005-06-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* IISAPIRuntime.cs: GUID changed.

2004-08-03  Atsushi Enomoto  <atsushi@ximian.com>

	* IApplicationHost.cs : missing namespace import.

2004-08-02  Duncan Mak  <duncan@ximian.com>

	* IApplicationHost.cs (MapPath): Add [In] attribute.

	* IAppManagerAppDomainFactory.cs:
	* IProcessHostSupportFunction.cs: signature fixes.
	
2004-08-02  Duncan Mak  <duncan@ximian.com>

	* IApplicationHost.cs:
	* IHttpWorkerRequestHandler.cs:
	* IProcessHost.cs:
	* IProcessHostFactoryHelper.cs:
	* IProcessHostSupportFunction.cs:
	* IProcessPingCallback.cs:
	* IQueueHost.cs:
	* IRegisteredObject.cs: Added interfaces.
	
2004-06-18  Gert Driesen <drieseng@users.sourceforge.net>

	* IAppDomainFactory.cs: added missing marshalling attributes
	* IISAPIRuntime.cs: added missing marshalling attributes

2004-05-14  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AppDomainFactory.cs: set the Dynamic base for the AppDomain.

2004-03-18  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SimpleWorkerRequest.cs: patch from Aleksey Demakov that fixes
	MapPath when the virtual directory is the root virtual directory.

2004-01-14  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* IISAPIRuntime.cs: Fixed wrong attribute

2004-01-11  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* SimpleWorkerRequest.cs: Added missing attribute
	* IISAPIRuntime.cs: Added attributes, fixed signature
	* IAppDomainFactory.cs: Added attributes, fixed signature

2003-08-29  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: set hostingInstallDir.
	* SimpleWorkerRequest.cs: implemented a couple of properties.

2003-08-29  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SimpleWorkerRequest.cs: fixed GetFilePathTranslated and added a
	paranoid condition to ExtractPathInfo.

2003-06-25  Eric Lindvall <eric@5stops.com>

	* SimpleWorkerRequest.cs: 
		-adds PATH_INFO support
		- updates GetFilePathTranslated() to make use of Path.Combine()
		- gets rid of the null check in GetPathInfo() (we're setting
		_PathInfo to String.Empty now)
		- fixed CreatePath() so that it doesn't return String.Empty if
		  the _AppVirtualPath is not "/" (to match MS runtime -- does
		  anyone know why it was returning String.Empty?)

2003-03-17  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AppDomainFactory.cs: hacks to work-around our buggy System.Uri.

2003-03-17 George Kodinov <gkodinov@openlinksw.co.uk>
       
	* AppDomainFactory.cs: place the correct full path for Web.config when
	in Application host

2003-02-17  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AppDomainFactory.cs: Web.config takes precedence over web.config.

	* ApplicationHost.cs: removed hacks to work around an old bug.

2003-02-04  Tim Haynes <thaynes@openlinksw.com>

	* SimpleWorkerRequest.cs: changed the initialised values of
	_App{Install,Virtual}Path variables

2002-09-28  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* System.Web.Hosting/SimpleWorkerRequest.cs: we are now able to compile
	pages and use HttpApplication, HttpRuntime and SimpleWorkerRequest.

2002-09-26  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs:
	* SimpleWorkerRequest.cs: workaround for bug #31245. 

2002-08-26  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: little fixes.

2002-08-20  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ApplicationHost.cs: use Assembly instead of Module.

2002-08-05  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AppDomainFactory.cs: implemented.
	* ApplicationHost.cs: implemented.
	* SimpleWorkerRequest.cs: a few little fixes and reformatted. It's now
	fully implemented.

2002-07-12  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AppDomainFactory.cs:
	* IAppDomainFactory.cs:
	* IISAPIRuntime.cs:
	* ISAPIRuntime.cs: make them compile.

2002-04-10  Patrik Torstensson <patrik.torstensson@labs2.com>

        * ApplicationHost.cs: Test implementation to support testing.
        * SimpleWorkerRequest.cs: Rewrite and a almost full implementation.

2001-08-30  Bob Smith  <bob@thestuff.net>

        * AppDomainFactory.cs: Stubbed.
        * ApplicationHost.cs: Stubbed.
        * IAppDomainFactory.cs: Stubbed.
        * IISAPIRuntime.cs: Stubbed.
        * ISAPIRuntime.cs: Implemented.
        * SimpleWorkerRequest.cs: Implemented.
